#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>

//assume 24-bit 64xH, where H >= ceil(CHARS/8)*8
#define CHARS	31
#define CHARH	8
#define H		(((CHARS+CHARH-1)/CHARH)*CHARH)

int main(void) {
	FILE *bmp = fopen("font.bmp", "rb");
	FILE *out;
	unsigned char data[CHARS][CHARH] = {{0}};
	int c, x, y;
	int w = 0, h = 0;
	int rgb[H][64] = {{0}};

	if (!bmp) {
		printf("Failed to open font.bmp!\n");
		return 1;
	}

	fseek(bmp, 18, SEEK_SET);
	fread(&w, 4, 1, bmp);
	fread(&h, 4, 1, bmp);

	if (w != 64 || h < H) {
		printf("Dimensions are %ix%i, expected 64x%i or taller\n", w, h, H);
		return 1;
	}

	//BMP is stored upside-down -> skip the first h-H lines
	fseek(bmp, 54 + 64*3*(h-H), SEEK_SET);

	for (y = H-1; y >= 0; y--)
		for (x = 0; x < 64; x++)
			fread(&rgb[y][x], 3, 1, bmp);

	ftell(bmp);

	for (c = 0; c < CHARS; c++)
		for (y = 0; y < CHARH; y++)
			for (x = 0; x < 8; x++)
				if (!rgb[(c/8)*CHARH+y][((c%8)*8)+x])
					data[c][CHARH-1-y] |= 1 << x;

	if (!(out = fopen("../font.h", "w"))) {
		printf("Failed to open font.h\n");
		return 1;
	}

	fprintf(out, "Font\n");
	for (x = 0; x < CHARS; x++) {
		if      (x == 26) fprintf(out, "CharAA\n");
		else if (x == 27) fprintf(out, "CharAE\n");
		else if (x == 28) fprintf(out, "CharOE\n");
		else if (x == 29) fprintf(out, "CharSlash\n");
		else if (x == 30) fprintf(out, "CharEquals\n");
		else              fprintf(out, "Char%c\n", x + 'A');

		for (y = 0; y < CHARH; y++) {
#define B(b) ((data[x][y] >> b) & 1)
			fprintf(out, "\t.byte %%%i%i%i%i%i%i%i%i\n",
			        B(0), B(1), B(2), B(3), B(4), B(5), B(6), B(7));
		}

		fprintf(out, "\n");
	}

	fclose(bmp);
	fclose(out);
	return 0;
}
