;Each sound effect consists of two parts:
;* a one byte header specifying the length of the effect in frames
;* two bytes for each frame, containing the bits to be sent to the audio registers
;  like sprites, the are stored in "upside-down" order
;  their bits are as follows:
; - B0 b0-4: AUDFx
; - B1 b0-3: AUDCx
; - B1 b4-7: AUDVx
;
;  alternatively (MSB to LSB):
;   VVVV CCCC ...F FFFF
;
;  in .word format this looks like
;   $fFVC	;f is the topmost bit of F
; 
;TODO: how do we handle both PAL and NTSC? only PAL for now
;      we could simply not care, or repeat every fifth sample, or have separate effects for both

	;It's easier to change this macro then every damn
	;FCV value when we need to change their packing
	MAC	FCV
.F	SET {1}
.C	SET {2}
.V	SET {3}
	.word (.F << 8) | (.V << 4) | .C
	ENDM

BellHop
#if PAL
	.byte 24
#else
    .byte 28
#endif
	FCV 5, 4, 4
	FCV 5, 4, 8
	FCV 5, 4, 10
#if !PAL
    FCV 5, 4, 12
    FCV 5, 4, 12
#endif
	FCV 5, 4, 12
	FCV 5, 4, 12
	FCV 5, 4, 12
	FCV 5, 4, 12
	FCV 5, 4, 12
	FCV 5, 4, 12
	FCV 5, 4, 12
	FCV 6, 4, 8
	FCV 7, 4, 4

BirdHop
#if PAL
	.byte 36
#else
    .byte 42
#endif
	FCV 9, 4, 1
	FCV 9, 4, 2
	FCV 9, 4, 3
	FCV 9, 4, 5
#if !PAL
    FCV 9, 4, 6
#endif
	FCV 9, 4, 7
	FCV 9, 4, 9
#if !PAL
    FCV 9, 4, 10
#endif
	FCV 9, 4, 10
	FCV 9, 4, 11
	FCV 9, 4, 12
	FCV 9, 4, 13
	FCV 9, 4, 14
#if !PAL
    FCV 9, 4, 15
#endif
	FCV 9, 4, 15
	FCV 9, 4, 15
	FCV 9, 4, 14
	FCV 9, 4, 13
	FCV 9, 4, 12
	FCV 16, 4, 8	;FIXME? the hex values for these two used to be
	FCV 17, 4, 4	;$10 and $11, which may have been a typo

NewHiscore
	.byte 58
	FCV 5, 4, 8
	FCV 5, 4, 8
	FCV 5, 4, 8
	FCV 5, 4, 9
	FCV 5, 4, 10
	FCV 5, 4, 11
	FCV 5, 4, 12
	FCV 5, 4, 13
	FCV 5, 4, 14
	FCV 5, 4, 15
	FCV 5, 4, 8
	FCV 0, 0, 0
	FCV 0, 0, 0
	FCV 6, 4, 12
	FCV 6, 4, 13
	FCV 6, 4, 15
	FCV 6, 4, 8
	FCV 0, 0, 0
	FCV 0, 0, 0
	FCV 8, 4, 12
	FCV 8, 4, 13
	FCV 8, 4, 15
	FCV 8, 4, 8
	FCV 0, 0, 0
	FCV 0, 0, 0
	FCV 10, 4, 12
	FCV 10, 4, 13
	FCV 10, 4, 15
	FCV 10, 4, 8

NoHiscore
	.byte 10
	FCV 24, 1, 6
	FCV 24, 1, 7
	FCV 22, 1, 8
	FCV 22, 1, 9
	FCV 22, 1, 8

;Note: If we kept all the instruments on one page we could
;shave off a few more bytes of ROM by not having to store
;this LUT.
;Rather we could simply LDY #<InstrumentName before calling
;LoadFreeChannel and touch insptrx+1 only during setup.
;This would simplify the code, saving yet more ROM.
Instruments
	.word BellHop
	.word BirdHop
	.word NewHiscore
	.word NoHiscore
